set echo off
set termout off
set autotrace off

alter session set nls_date_format='dd-mm-yyyy hh24:mi:ss';

create table t
( time     date
, quantity number(3)
);

dbms_stats.gather_table_stats('RWIJK','T');

insert into t values (TRUNC(SYSDATE) + 12/24 + 22/24/60 + 1/24/60/60,100);
insert into t values (TRUNC(SYSDATE) + 12/24 + 22/24/60 + 3/24/60/60,200);
insert into t values (TRUNC(SYSDATE) + 12/24 + 22/24/60 + 4/24/60/60,300);
insert into t values (TRUNC(SYSDATE) + 12/24 + 22/24/60 + 6/24/60/60,200);
insert into t values (TRUNC(SYSDATE) + 12/24 + 22/24/60 + 45/24/60/60,100);
insert into t values (TRUNC(SYSDATE) + 12/24 + 22/24/60 + 46/24/60/60,200);
insert into t values (TRUNC(SYSDATE) + 12/24 + 23/24/60 + 12/24/60/60,100);
insert into t values (TRUNC(SYSDATE) + 12/24 + 23/24/60 + 12/24/60/60,200);

set termout on
clear screen

select * from t;

pause
set echo on

select time
     , quantity
     , lag(time) over (order by time) previous_time
     , row_number() over (order by time) row_num
  from t
order by time

pause
/

pause

select time
     , quantity
     , case
       when time - previous_time > 3/24/60/60
         or previous_time is null
       then row_num
       end rn
  from ( select time
              , quantity
              , lag(time) over (order by time) previous_time
              , row_number() over (order by time) row_num
           from t
       )
 order by time

pause
/
pause

select time
     , quantity
     , max(rn) over (order by time) max_rn
  from ( select time
              , quantity
              , case
                when time - previous_time > 3/24/60/60
                  or previous_time is null
                then row_num
                end rn
           from ( select time
                       , quantity
                       , lag(time) over (order by time) previous_time
                       , row_number() over (order by time) row_num
                    from t
                )
          order by time
       )

pause
/
pause

set autotrace on explain

select min(time)
     , max(time)
     , sum(quantity)
  from ( select time
              , quantity
              , max(rn) over (order by time) max_rn
           from ( select time
                       , quantity
                       , case
                         when time - previous_time > 3/24/60/60
                           or previous_time is null
                         then row_num
                         end rn
                    from ( select time
                                , quantity
                                , lag(time) over (order by time) previous_time
                                , row_number() over (order by time) row_num
                             from t
                         )
                )
       )
 group by max_rn
 order by 1

pause
/
set autotrace off
set echo off
drop table t purge
/
