break on deptno skip 1
set echo on
set serveroutput off
clear screen
create table big_emp
as
select rownum empno
     , substr(object_name,1,30) ename
     , 500 + mod(rownum * 100, 4500) sal
     , 10 + mod(rownum * 10,40) deptno
  from dba_objects
 where rownum < 10001
/
select count(*) from big_emp;
pause
alter session set statistics_level = all
/
select deptno
     , ename
     , sal
     , sum(sal) over (partition by deptno order by sal,ename) cumulative_salary
     , round(100 * ratio_to_report(sal) over (partition by deptno), 1) percentage_dept
     , round(100 * ratio_to_report(sal) over (), 1) percentage_total
  from big_emp
 order by deptno
     , sal

set termout off
/
set termout on
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
pause

select emp.deptno
     , emp.ename
     , emp.sal
     , sum(emp4.sal) cumulative_sal
     , round(100 * emp.sal/emp2.sal_dept, 1) percentage_dept
     , round(100 * emp.sal/emp3.sal_totaal, 1) percentage_total
  from big_emp emp
     , (  select deptno, sum(sal) sal_dept
            from big_emp
        group by deptno
       ) emp2
     , ( select sum(sal) sal_totaal
           from big_emp
       ) emp3
     , big_emp emp4
 where emp.deptno = emp2.deptno
   and emp.deptno = emp4.deptno
   and (  emp.sal > emp4.sal
       or (   emp.sal = emp4.sal
          and emp.ename >= emp4.ename
          )
       )
 group by emp.deptno
     , emp.ename
     , emp.sal
     , round(100 * emp.sal/emp2.sal_dept, 1)
     , round(100 * emp.sal/emp3.sal_totaal, 1)
 order by deptno
     , sal

set termout off
/
set termout on
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
alter session set statistics_level = typical
/
set echo off
set serveroutput on
drop table big_emp purge
/
clear breaks
