set termout off
set echo off
clear screen
create table notas
( id         number(4)
, rle_nummer number(7)
, act_volgnr number(3)
, nota_datum date
, soort      varchar2(3)
)
/
create table notaregels
( id         number(4)
, nta_id     number(9)
, soort      varchar2(3)
)
/
create table notaregel_details
( nrl_id     number(4)
, bedrag     number(9,2)
)
/
insert into notas
select rownum
     , 1009400
     , 1
     , ADD_MONTHS(TO_DATE('01012003','ddmmyyyy'),rownum)
     ,'PER'
  from all_objects
 where rownum < 16
/
insert into notaregels
select rownum
     , rownum-TRUNC((rownum+11)/13)
     , DECODE(mod(rownum-1,13),0,'PRA','VOO')
  from all_objects
 where rownum < 18
/
insert into notaregel_details values (1,352.46);
insert into notaregel_details values (2,41.19);
insert into notaregel_details values (3,41.19);
insert into notaregel_details values (4,41.19);
insert into notaregel_details values (5,41.19);
insert into notaregel_details values (6,41.19);
insert into notaregel_details values (7,41.19);
insert into notaregel_details values (8,41.19);
insert into notaregel_details values (9,41.19);
insert into notaregel_details values (10,41.19);
insert into notaregel_details values (11,41.19);
insert into notaregel_details values (12,41.19);
insert into notaregel_details values (13,41.19);
insert into notaregel_details values (14,548.14);
insert into notaregel_details values (15,49.42);
insert into notaregel_details values (16,49.42);
insert into notaregel_details values (17,49.42);
set echo on
set termout on
clear screen
select *
  from notas
/
pause
select *
  from notaregels
/
pause
select *
  from notaregel_details
/
pause
select nta.id          nta_id
     , nta.nota_datum
     , nrl.id          nrl_id
     , nrl.soort       nrl_soort
     , sum(nrd.bedrag) totaalbedrag
  from notaregel_details nrd
     , notaregels        nrl
     , notas             nta
 where nta.id = nrl.nta_id
   and nrl.id = nrd.nrl_id
   and nta.soort = 'PER'
   and nrl.soort IN ('PRA','VOO')
 group by nta.id
     , nta.nota_datum
     , nrl.id
     , nrl.soort
 order by nta.nota_datum
/
pause
SELECT nrl.soort                                           nrl_soort
,      LEAD(nrl.soort) OVER (ORDER BY nta.nota_datum)      volgende_nrl_soort
,      LEAD(nta.nota_datum) OVER (ORDER BY nta.nota_datum) volgende_nota_datum
,      MAX(CASE nrl.soort
           WHEN 'PRA' THEN nta.nota_datum
           WHEN 'VOO' THEN TO_DATE('1','J')
           END
           ) OVER ()                                       max_notadatum_pra
,      SUM(nrd.bedrag)                                     totaalbedrag
FROM   notaregel_details nrd
,      notaregels        nrl
,      notas             nta
WHERE  nta.id = nrl.nta_id
AND    nrl.id = nrd.nrl_id
AND    nta.soort              = 'PER'
AND    nrl.soort             IN ('PRA','VOO')
GROUP  BY nta.id
,      nta.nota_datum
,      nrl.soort

pause
/
pause

SELECT NVL(totaalbedrag,0) vorig_totaalbedrag
FROM   ( SELECT nrl.soort                                           nrl_soort
         ,      LEAD(nrl.soort) OVER (ORDER BY nta.nota_datum)      volgende_nrl_soort
         ,      LEAD(nta.nota_datum) OVER (ORDER BY nta.nota_datum) volgende_nota_datum
         ,      MAX(CASE nrl.soort
                    WHEN 'PRA' THEN nta.nota_datum
                    WHEN 'VOO' THEN TO_DATE('1','J')
                    END
                   ) OVER ()                                        max_notadatum_pra
         ,      SUM(nrd.bedrag)                                     totaalbedrag
         FROM   notaregel_details nrd
         ,      notaregels        nrl
         ,      notas             nta
         WHERE  nta.id = nrl.nta_id
         AND    nrl.id = nrd.nrl_id
         AND    nta.soort              = 'PER'
         AND    nrl.soort             IN ('PRA','VOO')
         GROUP  BY nta.id
         ,      nta.nota_datum
         ,      nrl.soort
       )
WHERE  nrl_soort           = 'VOO'              /* Select the prepayment bill */
AND    volgende_nrl_soort  = 'PRA'              /* Whose next bill is a settlement bill */
AND    volgende_nota_datum = max_notadatum_pra  /* And whose bill date is equal to the most recent settlement bill date */

pause
/
set echo off
drop table notas purge
/
drop table notaregels purge
/
drop table notaregel_details purge
/
