set echo on
column all_employees format a50
clear screen
select deptno
     , stddev(sal)
  from emp
 group by deptno
/
pause
remark
remark  Since 11.2.0.1: Built-in string aggregation
remark
select deptno
     , listagg(ename,',') within group (order by ename) all_employees
  from emp
 group by deptno
/
pause
remark
remark  CORR:   Pearson's correlation coefficients
remark  CORR_S: Spearman's rho correlation coefficient
remark  CORR_K: Kendall's tau-b correlation coefficient
remark
select corr_s(sal,comm)
     , corr_k(sal,comm,'COEFFICIENT') coefficient
     , corr_k(sal,comm,'TWO_SIDED_SIG') two_sided_p_value
  from emp
/
pause
remark
remark  Other aggregate functions:
remark  * AVG
remark  * COLLECT
remark  * CORR
remark  * CORR_*
remark  * COUNT
remark  * COVAR_POP
remark  * COVAR_SAMP
remark  * CUME_DIST
remark  * DENSE_RANK
remark  * FIRST
remark  * GROUP_ID
remark  * GROUPING
remark  * GROUPING_ID
remark  * LAST
remark  * MAX
remark  * MEDIAN
remark  * MIN
remark  * PERCENTILE_CONT
remark  * PERCENTILE_DISC
remark  * PERCENT_RANK
remark  * RANK
remark  * REGR_ (Linear Regression) Functions
remark  * STATS_BINOMIAL_TEST
remark  * STATS_CROSSTAB
remark  * STATS_F_TEST
remark  * STATS_KS_TEST
remark  * STATS_MODE
remark  * STATS_MW_TEST
remark  * STATS_ONE_WAY_ANOVA
remark  * STATS_T_TEST_*
remark  * STATS_WSR_TEST
remark  * STDDEV
remark  * STDDEV_POP
remark  * STDDEV_SAMP
remark  * SUM
remark  * SYS_XMLAGG
remark  * VAR_POP
remark  * VAR_SAMP
remark  * VARIANCE
remark  * XMLAGG
remark
pause
remark
remark  What does a RANK aggregate function do?
remark
select deptno
     , rank(4000) within group (order by sal desc)
  from emp
 group by deptno
/
pause
remark
remark  Which department has the most employees?
remark
select stats_mode(deptno)
  from emp
/ 
set echo off
