set echo on
spool dmws1.txt
clear screen
remark
remark  End all open contracts for customers that haven't shown any activity for the past year.
remark  '
pause
create table all_contracts (nr,customer_id,startdate,enddate)
as
 select level
      , level
      , date '2000-01-01'
      , cast(null as date)
   from dual
connect by level <= 20000
/
alter table all_contracts add constraint all_contracts_pk primary key (nr)
/
alter table all_contracts add constraint all_contracts_uk unique (customer_id,startdate)
/
exec dbms_stats.gather_table_stats(user,'all_contracts',cascade=>true)
pause
create table activity (id,customer_id,activitydate)
as
 select level
      , 5000 + level
      , trunc(sysdate) - dbms_random.value(1,365)
   from dual
connect by level <= 10000
/
alter table activity add constraint activity_pk primary key (id)
/
create index i1 on activity(customer_id)
/
exec dbms_stats.gather_table_stats(user,'activity',cascade=>true)
pause
create procedure p1
as
  cursor c_customers
  is
  select c.customer_id
    from all_contracts c
   where c.enddate is null
         for update of c.enddate
  ;
  cursor c_activity (p_customer_id in activity.customer_id%type)
  is
  select 'found'
    from activity a
   where a.customer_id = p_customer_id
     and a.activitydate >= add_months(trunc(sysdate),-12)
  ;
  l_found varchar2(5);
begin
  for r_customers in c_customers
  loop
    open c_activity (r_customers.customer_id);
    fetch c_activity into l_found;
    if c_activity%notfound
    then
      close c_activity
      ;
      update all_contracts
         set enddate = sysdate
       where current of c_customers
      ;
    else
      close c_activity;
    end if;
  end loop;
end p1;
/
pause
set timing on
exec p1
set timing off
select count(*)
  from all_contracts
 where enddate is not null
/
rollback
/
pause
set timing on
exec p1
set timing off
rollback
/
pause
set timing on
update all_contracts c
   set c.enddate = sysdate
 where c.enddate is null
   and c.customer_id not in
       ( select a.customer_id
           from activity a
          where a.activitydate >= add_months(trunc(sysdate),-12)
       )
/
set timing off
rollback
/
pause
set timing on
update all_contracts c
   set c.enddate = sysdate
 where c.enddate is null
   and c.customer_id not in
       ( select a.customer_id
           from activity a
          where a.activitydate >= add_months(trunc(sysdate),-12)
       )
/
set timing off
rollback
/
set echo off
drop procedure p1
/
drop table all_contracts purge
/
drop table activity purge
/
spool off
