set echo on
column value format a100
clear screen
create table t (grp,string)
as
select 'grp1', 'aa,b,ccc,d,e,ffff,gg,hhh' from dual union all
select 'grp2', 'aa,,i' from dual union all
select 'grp3', null from dual union all
select 'grp4', 'jj,k,lll' from dual
/
select * from t
/
pause
clear screen
select t.grp
     , t.string
     , n
  from t
     , (select level n from dual connect by level <= 1000)
 where n <= length(t.string) - length(replace(t.string,',')) + 1
 order by t.grp
     , n
/
pause
clear screen
select t.grp
     , substr
       ( ',' || t.string || ','
       , instr(',' || t.string || ',', ',', 1, n) + 1
       , instr(',' || t.string || ',', ',', 1, n+1) - instr(',' || t.string || ',', ',', 1, n) - 1
       ) value
  from t
     , (select level n from dual connect by level <= 1000)
 where n <= length(t.string) - length(replace(t.string,',')) + 1
 order by t.grp
     , value
/
pause
clear screen
select t.grp
     , regexp_substr(t.string,'[^,]+',1,n) value
  from t
     , (select level n from dual connect by level <= 1000)
 where n <= regexp_count(t.string,',') + 1
 order by t.grp
     , value
/
pause
clear screen
select t.grp
     , regexp_substr(t.string,'[^,]+',1,n) value
  from t
     , ( select level n
           from (select max(regexp_count(string,',')+1) maxparts from t)
        connect by level <= maxparts
       )
 where n <= regexp_count(t.string,',') + 1
 order by t.grp
     , value
/
pause
clear screen
remark
remark  Multiset
remark
select t.grp
     , regexp_substr(t.string,'[^,]+',1,row_number() over (partition by t.grp order by null)) value
  from t
     , table
       ( cast
         ( multiset(select null from dual connect by rownum <= regexp_count(t.string,',')+1)
           as sys.dbms_debug_vc2coll
         )
       ) x
 order by t.grp
     , value
/
pause
clear screen
remark
remark  Model clause
remark
select grp
     , value
  from t
 model
       return updated rows
       partition by (grp)
       dimension by (0 i)
       measures (string value)
       rules
       ( value[for i from 1 to regexp_count(value[0],',')+1 increment 1] = regexp_substr(value[0],'[^,]+',1,cv(i))
       )
 order by grp
     , value
/
pause
clear screen
remark
remark  Recursive Subquery Factoring
remark
with tr (grp,piece,string,part) as
( select grp
       , substr(string,1,instr(string,',')-1)
       , substr(string,instr(string,',')+1)
       , 1
    from t
   union all
  select grp
       , substr(string,1,instr(string,',')-1)
       , regexp_substr(string,'[^,]+,(.*)',1,1,'',1)
       , part + 1
    from tr
   where string is not null
)
select grp
     , piece value
  from tr
 order by grp
     , part
/
set echo off
drop table t purge
/
clear breaks
