set echo on
set serveroutput off
clear screen
remark
remark  Tabibitosan, from Aketi Jyuuzou
remark  http://forums.oracle.com/forums/thread.jspa?messageID=3989678
remark
remark  For grouping consecutive rows
remark
create table t (num)
as
select  1 from dual union all
select  2 from dual union all
select  3 from dual union all
select  5 from dual union all
select  6 from dual union all
select  7 from dual union all
select 10 from dual union all
select 11 from dual union all
select 12 from dual union all
select 20 from dual union all
select 21 from dual
/
pause
select num
     , row_number() over (order by num) rn
     , num - row_number() over (order by num) grp
  from t
/
pause
with tabibitosan as
( select num
       , num - row_number() over (order by num) grp
    from t
)
select min(num)
     , max(num)
     , count(*)
  from tabibitosan
 group by grp
 order by min(num)
/
pause
drop table t purge
/
clear screen
remark
remark  Example from: http://boneist-oracle.livejournal.com/#boneist_oracle7389, with some adjustments
remark
create table t (id,dt)
as
select 1, date '2011-01-01' from dual union all
select 1, date '2011-01-02' from dual union all
select 1, date '2011-01-03' from dual union all
select 1, date '2011-01-04' from dual union all
select 1, date '2011-01-05' from dual union all
select 1, date '2011-01-10' from dual union all
select 1, date '2011-01-11' from dual union all
select 1, date '2011-01-12' from dual union all
select 1, date '2011-01-14' from dual union all
select 1, date '2011-01-15' from dual union all
select 1, date '2011-01-16' from dual union all
select 2, date '2011-01-01' from dual union all
select 2, date '2011-01-02' from dual union all
select 2, date '2011-01-03' from dual union all
select 2, date '2011-01-04' from dual union all
select 2, date '2011-01-06' from dual union all
select 2, date '2011-01-07' from dual union all
select 2, date '2011-01-11' from dual union all
select 2, date '2011-01-12' from dual union all
select 2, date '2011-01-13' from dual union all
select 2, date '2011-01-29' from dual union all
select 2, date '2011-01-30' from dual union all
select 2, date '2011-01-31' from dual union all
select 2, date '2011-02-01' from dual
/
exec dbms_stats.gather_table_stats(user,'t')
pause
select id
     , dt
     , to_number(to_char(dt, 'j')) date_as_number
     , row_number() over (partition by id order by dt) partitioned_rn
     , to_number(to_char(dt, 'j')) - row_number() over (partition by id order by dt) grp
  from t
/ 
select id
     , dt
     , row_number() over (partition by id order by dt) partitioned_rn
     , dt - row_number() over (partition by id order by dt) grp
  from t
/ 
pause
alter session set statistics_level = all
/
with tabibitosan as
( select id
       , dt
       , dt - row_number() over (partition by id order by dt) grp
    from t
)
select id
     , min(dt) min_dt
     , max(dt) max_dt
  from tabibitosan
 group by id
     , grp
 order by id
     , grp
/
pause
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
alter session set statistics_level = typical
/
set echo off
set serveroutput on
drop table t purge
/
