set echo on
column ename format a12
column cbr format a20
clear screen
 select lpad(' ', 2*(level-1), ' ') || ename as ename
      , empno
      , mgr
      , deptno
      , connect_by_isleaf
   from emp
connect by mgr = prior empno
  start with ename = 'KING'
  order siblings by deptno
/
pause
clear screen
with emps (empno,ename,mgr,deptno,lvl) as
( select empno
       , ename
       , mgr
       , deptno
       , 1
    from emp
   where mgr is null
   union all
  select e.empno
       , e.ename
       , e.mgr
       , e.deptno
       , e2.lvl + 1
    from emp e
       , emps e2
   where e.mgr = e2.empno
) search depth first by deptno set seq
select rpad(' ', 2  * (lvl-1), ' ') || ename as ename
     , empno
     , mgr
     , deptno
     , case
       when lvl - lead(lvl) over (order by seq) < 0 then
         0
       else
         1
       end is_leaf
     , lvl
     , seq
     , lead(lvl) over (order by seq) lead_lvl
  from emps
 order by seq
/
pause
clear screen
with emps (empno,ename,mgr,deptno,lvl) as
( select empno
       , ename
       , mgr
       , deptno
       , 1
    from emp
   where mgr is null
   union all
  select e.empno
       , e.ename
       , e.mgr
       , e.deptno
       , e2.lvl + 1
    from emp e
       , emps e2
   where e.mgr = e2.empno
) search breadth first by deptno set seq
select rpad(' ', 2  * (lvl-1), ' ') || ename as ename
     , empno
     , mgr
     , deptno
     , case
       when lvl - lead(lvl) over (order by seq) < 0 then
         0
       else
         1
       end is_leaf
     , lvl
     , seq
     , lead(lvl) over (order by seq) lead_lvl
  from emps
 order by seq
/
set echo off
