set echo on
set serveroutput off
column ename format a20
clear screen
with emps (ename,lvl,job,deptno,empno) as
( select ename
       , 1
       , job
       , deptno
       , empno
    from emp
   where mgr is null
   union all
  select emp.ename
       , emps.lvl + 1
       , emp.job
       , emp.deptno
       , emp.empno
    from emp
         join emps on (emp.mgr = emps.empno)
) search depth first by empno set a
select /*+ gather_plan_statistics */
       lpad(' ', 2 * lvl - 2, ' ') || ename as ename
     , lvl
     , job
     , deptno
  from emps
/
pause
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
pause
clear screen
 select /*+ connect_by_filtering gather_plan_statistics */
        lpad(' ', 2 * level - 2, ' ') || ename as ename
      , level
      , job
      , deptno
   from emp
connect by mgr = prior empno
  start with mgr is null
/
pause
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
pause
 select /*+ no_connect_by_filtering gather_plan_statistics */
        lpad(' ', 2 * level - 2, ' ') || ename as ename
      , level
      , job
      , deptno
   from emp
connect by mgr = prior empno
  start with mgr is null
/
pause
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
pause
 select /*+ gather_plan_statistics */
        lpad(' ', 2 * level - 2, ' ') || ename as ename
      , level
      , job
      , deptno
   from emp
connect by mgr = prior empno
  start with mgr is null
/
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
pause
set autotrace on
 select /*+ connect_by_filtering */
        lpad(' ', 2 * level - 2, ' ') || ename as ename
      , level
      , job
      , deptno
   from emp
connect by mgr = prior empno
  start with mgr is null
/
pause
 select /*+ no_connect_by_filtering */
        lpad(' ', 2 * level - 2, ' ') || ename as ename
      , level
      , job
      , deptno
   from emp
connect by mgr = prior empno
  start with mgr is null
/
set autotrace off
set serveroutput on
set echo off
