set echo on
remark
remark  From Vadim Tropashko
remark  http://vadimtropashko.wordpress.com/2009/03/25/variable-number-of-joins/
remark
create table die (face_id,face_value,probability)
as
select 1, 1, 1/4 from dual union all
select 2, 3, 1/4 from dual union all
select 3, 4, 1/4 from dual union all
select 4, 5, 1/12 from dual union all
select 5, 6, 1/12 from dual union all
select 6, 8, 1/12 from dual
/
select * from die order by face_id
/
pause
with njoins (face_value, probability, joins) as
( select d1.face_value
       , d1.probability
       , 1
    from die d1
   union all
  select d1.face_value + d2.face_value as sum
       , d1.probability * d2.probability as probability
       , joins + 1
    from njoins d1
       , die d2
   where d1.joins < 3
)
select face_value
     , sum(probability)
  from njoins
 where joins = 3
 group by rollup(face_value)
 order by face_value
/
pause
update die
   set probability = 1/6
     , face_value = face_id
/
select * from die
/
pause
with njoins (face_value, probability, joins) as
( select d1.face_value
       , d1.probability
       , 1
    from die d1
   union all
  select d1.face_value + d2.face_value as sum
       , d1.probability * d2.probability as probability
       , joins + 1
    from njoins d1
       , die d2
   where d1.joins < 2
)
select face_value
     , sum(probability)
  from njoins
 where joins = 2
 group by rollup(face_value)
 order by face_value
/
set echo off
drop table die purge
/
