set echo on
create table sales (product,month,amount)
as
select 'A', date '2009-01-01', 10 from dual union all
select 'A', date '2009-02-01', 15 from dual union all
select 'A', date '2009-03-01', 17 from dual union all
select 'A', date '2009-04-01', 20 from dual union all
select 'A', date '2009-05-01', 22 from dual union all
select 'A', date '2009-06-01', 20 from dual union all
select 'A', date '2009-07-01', 25 from dual union all
select 'A', date '2009-08-01', 27 from dual union all
select 'A', date '2009-09-01', 30 from dual union all
select 'A', date '2009-10-01', 35 from dual union all
select 'A', date '2009-11-01', 37 from dual union all
select 'A', date '2009-12-01', 40 from dual union all
select 'B', date '2009-01-01', 0 from dual union all
select 'B', date '2009-02-01', 50 from dual union all
select 'B', date '2009-03-01', 10 from dual union all
select 'B', date '2009-04-01', 40 from dual union all
select 'B', date '2009-05-01', 15 from dual union all
select 'B', date '2009-06-01', 35 from dual union all
select 'B', date '2009-07-01', 30 from dual union all
select 'B', date '2009-08-01', 30 from dual union all
select 'B', date '2009-09-01', 20 from dual union all
select 'B', date '2009-10-01', 20 from dual union all
select 'B', date '2009-11-01', 20 from dual union all
select 'B', date '2009-12-01', 20 from dual
/
pause
select *
  from sales
 order by product
     , month
/
pause
with res(product, month, amount, x ) as
( select r.product
       , min(r.month)
       , max(r.amount) keep (dense_rank first order by month)
       , max(r.amount) keep (dense_rank first order by month)
    from sales r
   group by r.product
   union all
  select s.product
       , s.month
       , s.amount
       , .5 * (s.amount - res.x) + res.x
    from sales s
       , res   res
   where s.month = res.month + interval '1' month
     and s.product = res.product
)
select product
     , month
     , amount
     , round(x,3) EMA
  from res
 order by product
     , month
/
set echo off
drop table sales purge
/
