set echo on
column sudoku format a9 wrapped
remark
remark  Slightly modified from Anton Scheffer's solution at
remark  http://technology.amis.nl/blog/6404/oracle-rdbms-11gr2-solving-a-sudoku-using-recursive-subquery-factoring
remark
select '53  7    6  195    98    6 8   6   34  8 3  17   2   6 6    28    419  5    8  79' sudoku
  from dual
/ 
pause
with sudoku_start as
( select '53  7    6  195    98    6 8   6   34  8 3  17   2   6 6    28    419  5    8  79' sud
    from dual
)
, all_numbers as
( select level n
    from dual
 connect by level <= 9
)
, sudoku(s,ind) as
( select sud
       , instr(sud,' ')
    from sudoku_start
   union all
  select substr( s, 1, ind - 1 ) || to_char(n) || substr( s, ind + 1 )
       , instr( s, ' ', ind + 1 )
    from all_numbers n
       , sudoku
   where ind > 0
     and not exists
         ( select null
             from all_numbers lp
            where to_char(n.n) in
                  ( substr( s, trunc( ( ind - 1 ) / 9 ) * 9 + lp.n, 1 )  -- horizontal
                  , substr( s, mod( ind - 1, 9 ) - 8 + lp.n * 9, 1 )     -- vertical
                  , substr
                    ( s
                    , mod( trunc( ( ind - 1 ) / 3 ), 3 ) * 3             -- horizontal start of block
                      + trunc( ( ind - 1 ) / 27 ) * 27                   -- vertical start of block
                      + lp.n + trunc( ( lp.n - 1 ) / 3 ) * 6             -- 1,2,3,10,11,12,19,20,21
                    , 1
                    )
                  )
         )
)
select s sudoku
  from sudoku
 where ind = 0
/

