set echo on
create table myemp as select * from emp
/
create table mydept as select * from dept
/
alter table myemp add (dname varchar2(10))
/
exec dbms_stats.gather_table_stats(user,'myemp',cascade=>true)
exec dbms_stats.gather_table_stats(user,'mydept')
pause
select empno
     , ename 
     , deptno
     , dname
  from myemp
 order by empno
/
pause
update myemp
   set dname =
       ( select dname
           from mydept
          where deptno = myemp.deptno
       )
/
pause
select empno
     , ename 
     , deptno
     , dname
  from myemp
 order by empno
/
pause
rollback
/
alter session set statistics_level = all
/
set serveroutput off
update myemp
   set dname =
       ( select dname
           from mydept
          where deptno = myemp.deptno
       )
/
pause
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
pause
alter session set statistics_level = typical
/
rollback
/
update ( select e.dname emp_dname
              , d.dname new_dname
           from myemp e
              , mydept d
          where e.deptno = d.deptno
       )
   set emp_dname = new_dname
/
pause
alter table mydept add constraint mydept_pk primary key (deptno)
/
exec dbms_stats.gather_table_stats(user,'mydept',cascade=>true)
pause
alter session set statistics_level = all
/
update ( select e.dname emp_dname
              , d.dname new_dname
           from myemp e
              , mydept d
          where e.deptno = d.deptno
       )
   set emp_dname = new_dname
/
pause
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
alter session set statistics_level = typical
/
pause
select empno
     , ename 
     , deptno
     , dname
  from myemp
 order by empno
/
set serveroutput on
set echo off
drop table myemp purge
/
drop table mydept purge
/
